Loading...
Searching...
No Matches
icu::Replaceable Class Referenceabstract

`Replaceable` is an abstract base class representing a string of characters that supports the replacement of a range of itself with a new string of characters. More...

`#include <rep.h>`

Inheritance diagram for icu::Replaceable:

## Public Member Functions

virtual | ~Replaceable ()
| Destructor.
int32_t | length () const
| Returns the number of 16-bit code units in the text.
char16_t | charAt (int32_t offset) const
| Returns the 16-bit code unit at the given offset into the text.
UChar32 | char32At (int32_t offset) const
| Returns the 32-bit code point at the given 16-bit offset into the text.
virtual void | extractBetween (int32_t start, int32_t limit, UnicodeString &target) const =0
| Copies characters in the range [start, limit) into the UnicodeString target.
virtual void | handleReplaceBetween (int32_t start, int32_t limit, const UnicodeString &text)=0
| Replaces a substring of this object with the given text.
virtual void | copy (int32_t start, int32_t limit, int32_t dest)=0
| Copies a substring of this object, retaining metadata.
virtual UBool | hasMetaData () const
| Returns true if this object contains metadata.
virtual Replaceable * | clone () const
| Clone this object, an instance of a subclass of Replaceable.
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor.
virtual UClassID | getDynamicClassID () const
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class.

## Protected Member Functions

| Replaceable ()
| Default constructor.
virtual int32_t | getLength () const =0
| Virtual version of length().
virtual char16_t | getCharAt (int32_t offset) const =0
| Virtual version of charAt().
virtual UChar32 | getChar32At (int32_t offset) const =0
| Virtual version of char32At().

## Detailed Description

`Replaceable` is an abstract base class representing a string of characters that supports the replacement of a range of itself with a new string of characters.

It is used by APIs that change a piece of text while retaining metadata. Metadata is data other than the Unicode characters returned by char32At(). One example of metadata is style attributes; another is an edit history, marking each character with an author and revision number.

An implicit aspect of the `Replaceable` API is that during a replace operation, new characters take on the metadata of the old characters. For example, if the string "the <b>bold</b> font" has range (4, 8) replaced with "strong", then it becomes "the <b>strong</b> font".

`Replaceable` specifies ranges using a start offset and a limit offset. The range of characters thus specified includes the characters at offset start..limit-1. That is, the start offset is inclusive, and the limit offset is exclusive.

`Replaceable` also includes API to access characters in the string: `length()`, `charAt()`, `char32At()`, and `extractBetween()`.

For a subclass to support metadata, typical behavior of `replace()` is the following:

- Set the metadata of the new text to the metadata of the first character replaced
- If no characters are replaced, use the metadata of the previous character
- If there is no previous character (i.e. start == 0), use the following character
- If there is no following character (i.e. the replaceable was empty), use default metadata.
- If the code point U+FFFF is seen, it should be interpreted as a special marker having no metadata

If this is not the behavior, the subclass should document any differences.

Author
  Alan Liu

Stable
  ICU 2.0

Definition at line 77 of file rep.h.

## Constructor & Destructor Documentation

## ~Replaceable()

virtual icu::Replaceable::~Replaceable | ( |  | ) |

virtual

Destructor.

Stable
  ICU 2.0

References char32At(), charAt(), and length().

## Replaceable()

icu::Replaceable::Replaceable | ( |  | ) |

inline protected

Default constructor.

Stable
  ICU 2.4

Definition at line 243 of file rep.h.

References Replaceable().

Referenced by clone(), and Replaceable().

## Member Function Documentation

## char32At()

UChar32 icu::Replaceable::char32At | ( | int32_t | offset | ) | const

inline

Returns the 32-bit code point at the given 16-bit offset into the text.

This assumes the text is stored as 16-bit code units with surrogate pairs intermixed. If the offset of a leading or trailing code unit of a surrogate pair is given, return the code point of the surrogate pair.

Parameters

  offset | an integer between 0 and `length()`-1 inclusive

Returns
  32-bit code point of text at given offset

Stable
  ICU 1.8

Definition at line 256 of file rep.h.

References char32At(), and getChar32At().

Referenced by char32At(), and ~Replaceable().

## charAt()

char16_t icu::Replaceable::charAt | ( | int32_t | offset | ) | const

inline

Returns the 16-bit code unit at the given offset into the text.

Parameters

  offset | an integer between 0 and `length()`-1 inclusive

Returns
  16-bit code unit of text at given offset

Stable
  ICU 1.8

Definition at line 251 of file rep.h.

References charAt(), and getCharAt().

Referenced by charAt(), and ~Replaceable().

## clone()

virtual Replaceable * icu::Replaceable::clone | ( |  | ) | const

virtual

Clone this object, an instance of a subclass of Replaceable.

Clones can be used concurrently in multiple threads. If a subclass does not implement clone(), or if an error occurs, then nullptr is returned. The caller must delete the clone.

Returns
  a clone of this object

See also
  getDynamicClassID

Stable
  ICU 2.6

Reimplemented in icu::UnicodeString.

References Replaceable().

## copy()

virtual void icu::Replaceable::copy | ( | int32_t | start,
|  | int32_t | limit,
|  | int32_t | dest )

pure virtual

Copies a substring of this object, retaining metadata.

This method is used to duplicate or reorder substrings. The destination index must not overlap the source range.

Parameters

  start | the beginning index, inclusive; `0 <= start <= limit`.
  limit | the ending index, exclusive; `start <= limit <= length()`.
  dest | the destination index. The characters from `start..limit-1` will be copied to `dest`. Implementations of this method may assume that `dest <= start || dest >= limit`.

Stable
  ICU 2.0

Implemented in icu::UnicodeString.

## extractBetween()

virtual void icu::Replaceable::extractBetween | ( | int32_t | start,
|  | int32_t | limit,
|  | UnicodeString & | target ) const

pure virtual

Copies characters in the range [start, limit) into the UnicodeString target.

Parameters

  start | offset of first character which will be copied
  limit | offset immediately following the last character to be copied
  target | UnicodeString into which to copy characters.

Returns
  A reference to target

Stable
  ICU 2.1

Implemented in icu::UnicodeString.

## getChar32At()

virtual UChar32 icu::Replaceable::getChar32At | ( | int32_t | offset | ) | const

protected pure virtual

Virtual version of char32At().

Stable
  ICU 2.4

Implemented in icu::UnicodeString.

Referenced by char32At().

## getCharAt()

virtual char16_t icu::Replaceable::getCharAt | ( | int32_t | offset | ) | const

protected pure virtual

Virtual version of charAt().

Stable
  ICU 2.4

Implemented in icu::UnicodeString.

Referenced by charAt().

## getLength()

virtual int32_t icu::Replaceable::getLength | ( |  | ) | const

protected pure virtual

Virtual version of length().

Stable
  ICU 2.4

Implemented in icu::UnicodeString.

Referenced by length().

## handleReplaceBetween()

virtual void icu::Replaceable::handleReplaceBetween | ( | int32_t | start,
|  | int32_t | limit,
|  | const UnicodeString & | text )

pure virtual

Replaces a substring of this object with the given text.

If the characters being replaced have metadata, the new characters that replace them should be given the same metadata.

Subclasses must ensure that if the text between start and limit is equal to the replacement text, that replace has no effect. That is, any metadata should be unaffected. In addition, subclasses are encouraged to check for initial and trailing identical characters, and make a smaller replacement if possible. This will preserve as much metadata as possible.

Parameters

  start | the beginning index, inclusive; `0 <= start <= limit`.
  limit | the ending index, exclusive; `start <= limit <= length()`.
  text | the text to replace characters `start` to `limit - 1`

Stable
  ICU 2.0

Implemented in icu::UnicodeString.

## hasMetaData()

virtual UBool icu::Replaceable::hasMetaData | ( |  | ) | const

virtual

Returns true if this object contains metadata.

If a Replaceable object has metadata, calls to the Replaceable API must be made so as to preserve metadata. If it does not, calls to the Replaceable API may be optimized to improve performance. The default implementation returns true.

Returns
  true if this object contains metadata

Stable
  ICU 2.2

Reimplemented in icu::UnicodeString.

## length()

int32_t icu::Replaceable::length | ( |  | ) | const

inline

Returns the number of 16-bit code units in the text.

Returns
  number of 16-bit code units in text

Stable
  ICU 1.8

Definition at line 246 of file rep.h.

References getLength(), and length().

Referenced by length(), icu::UnicodeString::operator std::u16string_view(), icu::UnicodeString::operator std::wstring_view(), icu::UnicodeString::operator=(), icu::UnicodeString::operator==(), icu::UnicodeString::toUTF8String(), icu::UnicodeString::toUTF8String(), and ~Replaceable().

The documentation for this class was generated from the following file:

- common/unicode/rep.h